/*
 * mixer_status.c - ߥɽΥץ
 * Copyright (c) 1994-96 Jeff Tranter (jeff_tranter@mitel.com)
 * Kurt Wall(kwall@xmission.com)˽
 */
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <sys/soundcard.h>

/* ֤ץȤ桼ƥƥե󥯥 */
void prn_stat(int condition);

int main(void)
{
    int fd;			/* ߥǥХΥե뵭һ */
    int level;			/* ܥ塼 */
    char *device = "/dev/mixer";
    /* ǥХΥӥåȥޥ */
    int recsrc, devmask, recmask, stereodevs, caps;
    /* ߥͥ̾ */
    const char *labels[] = SOUND_DEVICE_LABELS;
    int i;

    /* ɽФѤǥߥǥХ򳫤 */
    if((fd = open(device, O_RDONLY)) < 0) {
	perror("open");
	exit(EXIT_FAILURE);
    }

    /* ߥξ */
    if((ioctl(fd, SOUND_MIXER_READ_RECSRC, &recsrc)) < 0)
	perror("SOUND_MIXER_READ_RECSRC");
    if((ioctl(fd, SOUND_MIXER_READ_DEVMASK, &devmask)) < 0)
	perror("SOUND_MIXER_READ_DEVMASK");
    if((ioctl(fd, SOUND_MIXER_READ_RECMASK, &recmask)) < 0)
	perror("SOUND_MIXER_READ_RECMASK");
    if((ioctl(fd, SOUND_MIXER_READ_STEREODEVS, &stereodevs)) < 0)
	perror("SOUND_MIXER_READ_STEREODEVS");
    if((ioctl(fd, SOUND_MIXER_READ_CAPS, &caps)) < 0)
	perror("SOUND_MIXER_READ_CAPS");

    /* ߥξץȤ */
    printf("Status of %s:\n\n", device);
    printf("Mixer      Recording   Active     Stereo     Current\n");
    printf("Channel    Source      Source     Device      Level\n");
    printf("----------------------------------------------------\n");
     
    /* ٤ƤΥǥХˤĤƷ֤ */
    for (i = 0 ; i < SOUND_MIXER_NRDEVICES ; ++i) {
	/* ѲǽʥǥХˤΤ߶̣ */
	if((1 << i) & devmask) {
	    /* ֹͥ̾ץȤ */
	    printf("%2d %-8s", i, labels[i]);
	    /* 쥳ǥ󥰥Ǥ뤫 */
	    prn_stat((1 << i) & recmask);
	    /* Ư椫 */
	    prn_stat((1 << i) & recsrc);
	    /* ƥ쥪ǽĤ */
	    prn_stat((1 << i) & stereodevs);
	    /* ƥ쥪ʤξΥ٥ɽ */
	    if ((1 << i) & stereodevs) {
		if((ioctl(fd, MIXER_READ(i), &level)) < 0)
		    perror("SOUND_MIXER_READ");
		printf("  %3d%% %3d%%", level & 0xff, 
		       (level & 0xff00) >> 8);
	    } else { /* ͥΤ */
		if((ioctl(fd, MIXER_READ(i), &level)) < 0)
		    perror("SOUND_MIXER_READ");
		printf("    %3d%%", level & 0xff);
	    }
	    printf("\n");
	}
    }
    /* ¾Ū˥쥳ɤƤ뤫 */
    printf("\n: 쥳ɤ륽 ");
    if (!(caps & SOUND_CAP_EXCL_INPUT))
	printf("");
    printf("¾Ū\n");

    /* ߥǥХĤ */
    close(fd);
    return 0;
}

void prn_stat(int condition)
{
    condition ? printf("   YES    ") : printf("   NO     ");
}
