/*
 * liberr.c - 顼饤֥μ
 */
#include <errno.h>		/* errno */
#include <stdarg.h>		/* vararg*/
#include <stdlib.h>
#include <stdio.h>
#include "liberr.h"		/* ʬȤΥإå */

void err_ret(const char *fmt, ...)
{
    va_list ap;
    
    va_start(ap, fmt);
    err_prn(fmt, ap, NULL);
    va_end(ap);
    return;
}

void err_quit(const char *fmt, ...)
{
    va_list ap;

    va_start(ap, fmt);
    err_prn(fmt, ap, NULL);
    va_end(ap);
    exit(1);
}

void log_ret(char *logfile, const char *fmt, ...)
{
    va_list ap;

    va_start(ap, fmt);
    err_prn(fmt, ap, logfile);
    va_end(ap);
    return;
}

void log_quit(char *logfile, const char *fmt, ...)
{
    va_list ap;

    va_start(ap, fmt);
    err_prn(fmt, ap, logfile);
    va_end(ap);
    exit(1);
}

extern void err_prn(const char *fmt, va_list ap, char *logfile)
{
    int save_err;
    char buf[MAXLINELEN];
    FILE *plf;

    save_err = errno; /* ͤθƽФ¦ϽϤ뤳Ȥ˾Ϥ */
    vsprintf(buf, fmt, ap);
    sprintf(buf + strlen(buf), ": %s", strerror(save_err));
    strcat(buf, "\n");
    fflush(stdout); /* stdoutstderrͤƱ */
    if(logfile != NULL)
        if((plf = fopen(logfile, "a")) != NULL) {
            fputs(buf, plf);
            fclose(plf);
        } else
            fputs("եΥץ˼Ԥ\n", stderr);
    else
        fputs(buf, stderr);
    fflush(NULL); /* եå夹 */
    return;
}
